#include<iostream>
#include<algorithm>
#define endl "\n"
using namespace std;

int const MAXN=1000001;
long long n, m, par[MAXN], r[MAXN];

struct edge
{
    long long x, y, c1, c2, idx;
};

edge a[MAXN];

bool cmp(edge l, edge r)
{
    if(l.c1 == r.c1) return l.c2 > r.c2;
    else return l.c1 < r.c1;
}

void fill_data()
{
    for(int i=1;i<=n;i++)
    {
        par[i] = i;
        r[i] = 1;
    }
}

int find_parent(int i)
{
    if(par[i] == i) return i;
    else return par[i] = find_parent(par[i]);
}

void DSU(int x, int y)
{
    x = find_parent(x);
    y = find_parent(y);
    if(par[x] == par[y]) return;
    if(r[x] > r[y]) swap(x, y);
    par[x] = par[y];
    r[y] += r[x];
}

void read()
{
    cin>>n>>m;
    for(int i=1;i<=m;i++)
    {
        cin>>a[i].x>>a[i].y>>a[i].c1>>a[i].c2;
        a[i].idx = i;
    }
    fill_data();
    sort(a+1, a+m+1, cmp);
    for(int i=1;i<=m;i++)
    {
        if(find_parent(a[i].x) != find_parent(a[i].y))
        {
            DSU(a[i].x, a[i].y);
            cout<<a[i].idx<<endl;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    return 0;
}
