#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int maxn = 2*1e5+2;
int n, m, lead[maxn], sz[maxn];
struct edge
{
    int x, y, idx;
    long long int c1, c;
};
edge a[maxn];

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m ;
    int i, x, y;
    long long c1, c2;
    for (i=1; i<=m; ++i)
    {
        cin >> x >> y >> c1 >> c2 ;
        a[i] = {x, y, i, c1, (c1*c2)};
    }
}

bool cmp (edge a1, edge a2)
{
    if (a1.c1 < a2.c1) return true;
    if (a1.c1 > a2.c1) return false;
    return (a1.c > a2.c);
}

void init()
{
    for (int i=1; i<=n; ++i)
    {
        lead[i] = i;
        sz[i] = 1;
    }
}

int find_leader(int x)
{
    return lead[x] = ((x == lead[x]) ? x : find_leader(lead[x]));
}

bool DSU(int v1, int v2)
{
    int x = find_leader(v1);
    int y = find_leader(v2);
    if (x == y) return false;
    if (sz[x] < sz[y])
    {
        lead[x] = y;
        sz[y] += sz[x];
        sz[x] = 0;
    }
    else
    {
        lead[y] = x;
        sz[x] += sz[y];
        sz[y] = 0;
    }
    return true;
}

void solve()
{
    init();
    sort(a+1, a+m+1, cmp);
    int i, u, v;
    for (i=1; i<=m; ++i)
    {
        u = a[i].x;
        v = a[i].y;
        if (DSU(u, v))
        {
            cout << a[i].idx << endl;
        }
    }
}

int main()
{
    read();
    solve();
    return 0;
}