#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int maxn = 2*1e6+2;
long long n, m, lead[maxn], sz[maxn];
struct edge
{
    long long x, y, idx;
    long long c1, c2;
};
edge a[maxn];
vector <long long> ans;

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m ;
    long long i, x, y;
    long long c1, c2, c;
    for (i=1; i<=m; ++i)
    {
        cin >> x >> y >> c1 >> c2 ;
        a[i] = {x, y, i, c1, c2};
    }
}

bool cmp (edge a1, edge a2)
{
    if (a1.c1 < a2.c1) return true;
    if (a1.c1 > a2.c1) return false;
    return (a1.c2 > a2.c2);
}

void init()
{
    for (long long i=1; i<=n; ++i)
    {
        lead[i] = i;
        sz[i] = 1;
    }
}

long long find_leader(long long x)
{
    return lead[x] = ((x == lead[x]) ? x : find_leader(lead[x]));
}

bool DSU(long long v1, long long v2)
{
    long long x = find_leader(v1);
    long long y = find_leader(v2);
    if (x == y) return false;
    if (sz[x] < sz[y])
    {
        lead[x] = y;
        sz[y] += sz[x];
        sz[x] = 0;
    }
    else
    {
        lead[y] = x;
        sz[x] += sz[y];
        sz[y] = 0;
    }
    return true;
}

void solve()
{
    init();
    sort(a+1, a+m+1, cmp);
    long long i, u, v;
    for (i=1; i<=m; ++i)
    {
        u = a[i].x;
        v = a[i].y;
        if (DSU(u, v))
        {
            ans.push_back(a[i].idx);
        }
    }
}

void print()
{
    long long i, len = ans.size();
    for (i=0; i<len; ++i)
    {
        cout << ans[i] << endl;
    }
}

int main()
{
    read();
    solve();
    print();
    return 0;
}